package com.liang.dao;

import com.liang.entity.PrjMember;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 项目人员(PrjMember)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-10 11:21:54
 */
public interface PrjMemberDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjMember queryById(Integer id);

    /**
     * 通过人员姓名和项目id查询单条数据
     *
     * @return 实例对象
     */
    PrjMember queryByRyAndXm(String ryxm, Integer xm);

    /**
     * 查询指定行数据
     *
     * @param prjMember 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<PrjMember> queryAllByLimit(PrjMember prjMember, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjMember 查询条件
     * @return 总行数
     */
    long count(PrjMember prjMember);

    /**
     * 新增数据
     *
     * @param prjMember 实例对象
     * @return 影响行数
     */
    int insert(PrjMember prjMember);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjMember> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(List<PrjMember> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjMember> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjMember> entities);

    /**
     * 修改数据
     *
     * @param prjMember 实例对象
     * @return 影响行数
     */
    int update(PrjMember prjMember);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 获取项目人员
     *
     * @param map
     * @return
     */
    List<PrjMember> getMemberList(Map map);

    /**
     * 获取项目人员信息
     *
     * @param xm
     * @return
     */
    List<PrjMember> getMemberInfoList(Integer xm);

    /**
     * 批量删除项目人员
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);
}

